import { DiscUnionType, ConstructorsWithType, ObjKey, Constructors, Narrow, ConstructorExtras, Handlers, WithType, Without } from './types';
/**
 * Factory function that creates the disc-union functions. Use this
 * to have a different default discriminant than 'type'
 * @param factoryTypeKey - The default discriminant property of the functions
 */
export declare const factory: <FactoryTypeKey extends string>(factoryTypeKey: FactoryTypeKey) => {
    discUnion: <T extends Constructors, P extends string = "", TypeKey extends ObjKey | FactoryTypeKey = FactoryTypeKey>(constructors: T, typeKey?: TypeKey, prefix?: P) => ConstructorsWithType<T, TypeKey, P>;
    match: {
        <T_1 extends DiscUnionType<TypeKey_1>, R extends Handlers<T_1, unknown, TypeKey_1>, TypeKey_1 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(value: T_1, handlers: Handlers<T_1, unknown, TypeKey_1> extends R ? R : Handlers<T_1, unknown, TypeKey_1>, typeKey?: TypeKey_1 | undefined): R extends Handlers<T_1, infer RT, TypeKey_1> ? RT : never;
        <T_2 extends DiscUnionType<TypeKey_2>, R_1 extends Partial<Handlers<T_2, unknown, TypeKey_2>>, E, TypeKey_2 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(value: T_2, handlers: Handlers<T_2, unknown, TypeKey_2> extends R_1 ? R_1 : Partial<Handlers<T_2, unknown, TypeKey_2>>, otherwise: (value: Exclude<T_2, { [M in TypeKey_2]: keyof R_1; }>) => E, typeKey?: TypeKey_2 | undefined): E | (R_1 extends Partial<Handlers<T_2, infer RT_1, TypeKey_2>> ? RT_1 : never);
    };
    map: <T_3 extends DiscUnionType<TypeKey_3>, K extends T_3[TypeKey_3], R_2, TypeKey_3 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(type: K, obj: T_3, mapper: (o: Extract<T_3, { [M_1 in TypeKey_3]: K; }>) => R_2, typeKey?: TypeKey_3) => T_3 | R_2;
    get: {
        <T_4 extends DiscUnionType<TypeKey_4>, K_1 extends T_4[TypeKey_4], TypeKey_4 extends ObjKey = FactoryTypeKey>(type: K_1, obj: Extract<T_4, { [M_2 in TypeKey_4]: K_1; }>, typeKey?: TypeKey_4 | undefined): Extract<T_4, { [M_2 in TypeKey_4]: K_1; }>;
        <T_5 extends DiscUnionType<TypeKey_5>, K_2 extends T_5[TypeKey_5], TypeKey_5 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(type: K_2, obj: T_5, typeKey?: TypeKey_5 | undefined): Extract<T_5, { [M_3 in TypeKey_5]: K_2; }> | null;
    };
    is: <T_6 extends DiscUnionType<TypeKey_6>, K_3 extends T_6[TypeKey_6], TypeKey_6 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(type: K_3, value: T_6, typeKey?: TypeKey_6) => value is Extract<T_6, { [M_4 in TypeKey_6]: K_3; }>;
    validate: <T_7 extends DiscUnionType<TypeKey_7>, K_4 extends T_7[TypeKey_7], TypeKey_7 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(type: K_4, obj: T_7, typeKey?: TypeKey_7) => Extract<T_7, { [M_5 in TypeKey_7]: K_4; }>;
    createType: <T_8 extends ObjKey, O extends object, TypeKey_8 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(type: T_8, obj: O, typeKey?: TypeKey_8) => WithType<O, T_8, TypeKey_8>;
    attachExtras: <Fn extends (args: unknown[]) => DiscUnionType<TypeKey_9>, K_5 extends ObjKey, TypeKey_9 extends ObjKey | FactoryTypeKey = FactoryTypeKey>(fn: Fn, type: K_5, typeKey?: TypeKey_9) => Fn & ConstructorExtras<K_5, TypeKey_9>;
};
