"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.attachExtras = exports.createType = exports.validate = exports.is = exports.get = exports.match = exports.map = exports.discUnion = exports.factory = void 0;
var factory_1 = require("./factory");
Object.defineProperty(exports, "factory", { enumerable: true, get: function () { return factory_1.factory; } });
var fns = factory_1.factory("type");
__exportStar(require("./types"), exports);
/**
 * Accepts an object of constructor functions,
 * and wraps those functions to add a type property
 * to their result
 *
 * @function
 * @param constructors - Object containing constructors
 * @param typeKey - Discriminant property
 */
exports.discUnion = fns.discUnion;
/**
 * Returns the result of mapper if value is of the specified type,
 * otherwise returns the value unchanged
 *
 * @function
 * @param type - Type to match
 * @param obj - Value to map over
 * @param mapper - Function to be called on obj
 * @param typeKey - Discriminant property
 */
exports.map = fns.map;
/**
 * Takes an object to match, and an object of handlers whose
 * keys are the possible types of the discriminated union.
 *
 * Exhaustive unless an "otherwise" handler is passed in as a third argument,
 * in which case the handler object may be partial.
 *
 * @function
 * @param obj - Object to match
 * @param handlers - Object whose keys are possible types of the discriminated union, and whose values are handlers for those types
 * @param otherwise (optional) - Handler if no match is found
 * @param typeKey (optional) - Discriminant property
 * @returns Result of the matched handler, or the result of the "otherwise" handler
 */
exports.match = fns.match;
/**
 * Narrows the type of the value if it matches the specified type,
 * otherwise returns null
 *
 * @function
 * @param type - Type to match
 * @param obj - Value to get
 * @param typeKey - Discriminant property
 */
exports.get = fns.get;
/**
 * Determines if the value matches the specified type
 *
 * @function
 * @param type - Type to match
 * @param obj - Value to check
 * @param typeKey - Discriminant property
 */
exports.is = fns.is;
/**
 * Narrows the type of the value if it matches, throws
 * an error otherwise
 *
 * @function
 * @param type - Type to match
 * @param obj - Value to check
 * @param typeKey - Discriminant property
 */
exports.validate = fns.validate;
/**
 * Convenience function for adding a type discriminant
 * to an object
 *
 * @function
 * @param type - Type to create
 * @param obj - Value to use
 * @param typeKey - Discriminant property
 */
exports.createType = fns.createType;
/**
 * Attaches "static" properties and methods to constructor function
 *
 * @function
 * @param fn - Constructor
 * @param type - Type string
 * @param typeKey - Discriminant property
 */
exports.attachExtras = fns.attachExtras;
